Index: main/plugin-forms/pages/administrator/orphan-forms/view.xsl
===================================================================
--- main/plugin-forms/pages/administrator/orphan-forms/view.xsl	(revision 0)
+++ main/plugin-forms/pages/administrator/orphan-forms/view.xsl	(revision 0)
@@ -0,0 +1,79 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!--
+   Copyright 2016 Anyware Services
+
+   Licensed under the Apache License, Version 2.0 (the "License");
+   you may not use this file except in compliance with the License.
+   You may obtain a copy of the License at
+
+       http://www.apache.org/licenses/LICENSE-2.0
+
+   Unless required by applicable law or agreed to in writing, software
+   distributed under the License is distributed on an "AS IS" BASIS,
+   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+   See the License for the specific language governing permissions and
+   limitations under the License.
+   -->
+<xsl:stylesheet version="1.0" 
+                xmlns:i18n="http://apache.org/cocoon/i18n/2.1" 
+                xmlns:escape="org.apache.commons.lang.StringEscapeUtils"
+                xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
+                exclude-result-prefixes="escape">
+    
+    <xsl:param name="contextPath"/>
+    <xsl:param name="pluginName"/>
+    <xsl:param name="workspaceName"/>
+    <xsl:param name="workspaceURI"/>
+    
+    <xsl:variable name="workspaceContext"><xsl:value-of select="$contextPath"/><xsl:value-of select="$workspaceURI"/></xsl:variable>
+    
+    <xsl:variable name="resourcesPath"><xsl:value-of select="$contextPath"/>/plugins/forms/resources</xsl:variable>
+    
+    <xsl:template match="/">
+        <html>
+            <head>
+                <title><i18n:text i18n:key="PLUGINS_FORMS_ADMINISTRATOR_ORPHAN_FORMS_LABEL"/></title>
+            </head>
+            
+            <script>
+               <script type="text/javascript" src="{$contextPath}/plugins/{$pluginName}/resources/js/org/ametys/forms/OrphanForms.i18n.js"/>
+               
+               <script type="text/javascript">
+               
+                    org.ametys.forms.administration.OrphanForms.initialize ("<xsl:value-of select="$pluginName"/>");
+                    
+                    // Create the tool panel
+                    var panel = org.ametys.forms.administration.OrphanForms.createPanel ();
+                    <xsl:for-each select="table">
+                       org.ametys.forms.administration.OrphanForms.addElement (
+                           <xsl:value-of select="position()"/>,
+                           "<xsl:value-of select="@name"/>",
+                           "<xsl:value-of select="@total"/>"
+                       );
+                   </xsl:for-each>
+                   
+                   org.ametys.runtime.administrator.Panel.createPanel = function () 
+                   {
+                       return new Ext.Panel({
+                           region: 'center',
+                           
+                           baseCls: 'transparent-panel',
+                           border: false,
+                           layout: 'border',
+                           autoScroll: true,
+                           
+                           items : [
+                                org.ametys.forms.administration.OrphanForms._listView, 
+                                org.ametys.forms.administration.OrphanForms._rightPanel
+                           ]
+                       });
+                   }
+               </script>
+            </script>
+            
+            <body>
+            
+            </body>
+        </html>
+    </xsl:template>
+</xsl:stylesheet>
\ No newline at end of file
Index: main/plugin-forms/resources/js/org/ametys/forms/ClearFormEntriesButton.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/ClearFormEntriesButton.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/ClearFormEntriesButton.js	(revision 0)
@@ -0,0 +1,74 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.forms.buttons');
+
+org.ametys.forms.buttons.ClearFormEntriesButton = function(id, configuration, pluginName) 
+{
+	org.ametys.forms.buttons.ClearFormEntriesButton.superclass.constructor.call(this, id, configuration, pluginName);
+};
+
+Ext.extend(org.ametys.forms.buttons.ClearFormEntriesButton, org.ametys.ribbon.control.button.ActionSelectionButton, {});
+
+org.ametys.forms.buttons.ClearFormEntriesButton.prototype.onMessage = function (messages)
+{
+	for (var i=messages.length - 1; i >= 0; i--)
+	{
+		if (messages[i].getType().getName() == org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED)
+		{
+			var targets = messages[i].getTargets();
+			var allContentFormTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, this.checkTarget());
+			
+			// No content selected
+			if (allContentFormTargets.length == 0)
+			{
+				this.getElements().each(function(element) { element.setDisabled(true); });
+				this.updateTooltip(this.getConfiguration()["default-description"]);
+			}
+			else
+			{
+				for (var j=0; j < allContentFormTargets.length; j++)
+				{
+					var hasEntries = false;
+					var contentFormTarget = allContentFormTargets[j];
+					if (contentFormTarget.getParameters().hasEntries === true)
+					{
+						hasEntries = true;
+						break;
+					}
+				}
+				
+				this.getElements().each(function(element) { element.setDisabled(!hasEntries); });
+				
+				var tooltip = this.getConfiguration()["default-description"];
+				if (!hasEntries)
+				{
+					tooltip = this.getConfiguration()["no-entries-description"]
+				}
+				
+				this.updateTooltip(tooltip);
+				
+				return;
+			}
+		}
+	}
+}
+
+org.ametys.forms.buttons.ClearFormEntriesButton.prototype.checkTarget = function ()
+{
+	return function (target) { return target.getType() == 'content-form'; };
+}
+
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js	(revision 39963)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsActions.i18n.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -21,34 +21,16 @@
 
 org.ametys.forms.buttons.Action = {};
 
-org.ametys.forms.buttons.Action.exportForm = function (button, state, configuration, index)
-{
-    org.ametys.forms.ChooseForm.act(button.ribbonControl, org.ametys.forms.buttons.Action.exportSelectedForm);
-}
-
-org.ametys.forms.buttons.Action.showForm = function (button, state, configuration, index) // (id, configuration, pluginName)
-{
-	var control = typeof button == "string" ? org.ametys.ribbon.RibbonManager.getInstance().getControls()[button] : button.ribbonControl;
-    org.ametys.forms.ChooseForm.act(control, org.ametys.forms.buttons.Action.showSelectedForm);
-}
-
-org.ametys.forms.buttons.Action.exportSelectedForm = function (id, encodedLabel, label)
+org.ametys.forms.buttons.Action.showForm = function (controlId, controlConfiguration, controlPluginName)
 {
-	if (id != null)
-    {
-        var pluginName = org.ametys.forms.ChooseForm._pluginName;
-        var url = '/' + context.parameters.siteName + '/export/' + id + '/' + encodedLabel + '.xls';
-        
-        window.location.href = getPluginDirectUrl(pluginName) + url;
-    }
+    org.ametys.forms.ChooseForm.act(org.ametys.ribbon.RibbonManager.getInstance().getControls()[controlId], org.ametys.forms.buttons.Action.showSelectedForm);
 }
 
 org.ametys.forms.buttons.Action.showSelectedForm = function(id, encodedLabel, label)
 {
-	org.ametys.uitool.ToolsManager.getInstance().openTool('uitool-form-entries', { id: id, label: label});
+	org.ametys.uitool.ToolsManager.getInstance().openTool('uitool-form-entries', { id: id, encodedLabel: encodedLabel, label: label});
 }
 
-
 org.ametys.forms.ChooseForm = {};
 
 /**
@@ -59,7 +41,7 @@
 org.ametys.forms.ChooseForm._listview;
 
 /**
- * The current selected form
+ * The form currently selected
  */
 org.ametys.forms.ChooseForm._currentForm;
 
@@ -88,8 +70,6 @@
     }
     
     org.ametys.forms.ChooseForm.load();
-    
-    org.ametys.forms.ChooseForm._box.show();
 }
 
 org.ametys.forms.ChooseForm.delayedInitialize = function ()
@@ -144,7 +124,6 @@
     org.ametys.forms.ChooseForm._initialized = true;
     
     return true;
-    
 }
 
 org.ametys.forms.ChooseForm.load = function()
@@ -161,14 +140,14 @@
     org.ametys.forms.ChooseForm._listview.getStore().removeAll();
     
     var contents = result.selectNodes("content-forms/content");
+    var formsAmount = 0;
     
     for (var i = 0; i &lt; contents.length; i++)
     {
         var contentId = contents[i].getAttribute('id');
         var contentTitle = contents[i].getAttribute('title');
         
-        var forms = contents[i].selectNodes("form");
-        
+        var forms = contents[i].selectNodes('form');
         for (var j=0; j &lt; forms.length;j++)
         {
             var id = forms[j].getAttribute('id');
@@ -178,9 +157,11 @@
             
             org.ametys.forms.ChooseForm._listview.addElement(id, {name: name, encodedName: encodedName, displayName: displayName});
         }
+        
+        formsAmount += forms.length;
     }
     
-    if (contents.length == 0)
+    if (formsAmount == 0)
     {
         Ext.Msg.show({
            title: "<i18n:text i18n:key="PLUGINS_FORMS_CHOOSE_FORM_DIALOG_CAPTION"/>",
@@ -188,7 +169,35 @@
            buttons: Ext.Msg.OK,
            icon: Ext.MessageBox.INFO
         });
+        
+        return;
     }
+    
+    
+    if (formsAmount == 1)
+	{
+    	// Do not bother displaying a selection pop-up when there is only one form to select
+        // Select the first form "artificially", since the list view is never going to be rendered
+        var firstRecord = org.ametys.forms.ChooseForm._listview.store.getAt(0);
+        org.ametys.forms.ChooseForm._listview.getSelectionModel().selections.add(firstRecord);
+    	
+    	org.ametys.forms.ChooseForm.ok();
+	}
+    
+    if (formsAmount &gt; 1)
+	{
+    	// Select the first record after the dialog box list view is ready
+    	if (!org.ametys.forms.ChooseForm._listview.viewReady)
+		{
+    		org.ametys.forms.ChooseForm._listview.on('viewready', function(){org.ametys.forms.ChooseForm._listview.getSelectionModel().selectFirstRow();});
+		}
+    	else
+		{
+    		org.ametys.forms.ChooseForm._listview.getSelectionModel().selectFirstRow();
+		}
+
+    	org.ametys.forms.ChooseForm._box.show();
+	}
 }
 
 org.ametys.forms.ChooseForm.ok = function()
@@ -226,10 +235,34 @@
     org.ametys.forms.ChooseForm._box.hide();
 }
 
-
 //------------------------------------------------------------
 
 /**
+ * Export the form's entries to XLS
+ */
+org.ametys.forms.entry.exportFormEntries = function(controlId, controlConfiguration, controlPluginName)
+{
+	var targets = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
+	var formTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, function (target) { return target.getType() == 'content-form'});
+	
+	if (formTarget.length == 0)
+    {
+        Ext.Msg.show({
+           title: "<i18n:text i18n:key="PLUGINS_FORMS_CHOOSE_FORM_DIALOG_CAPTION"/>",
+           msg: "<i18n:text i18n:key="PLUGINS_FORMS_CHOOSE_FORM_DIALOG_NO_FORM_SELECTED"/>",
+           buttons: Ext.Msg.OK,
+           icon: Ext.MessageBox.INFO
+        });
+        return;
+    }
+	
+    var formId = formTarget.getParameters().id;
+    var formEncodedLabel = formTarget.getParameters().encodedLabel;
+
+    window.location.href = getPluginDirectUrl(controlPluginName) + '/' + context.parameters.siteName + '/export/' + formId + '/' + formEncodedLabel + '.xls';
+}
+
+/**
  * Delete selected form entries.
  */
 org.ametys.forms.entry.DeleteEntry = function(controlId, controlConfiguration, controlPluginName)
@@ -239,7 +272,8 @@
     
     if (formTarget != null)
     {
-    	var formId = formTarget.getParameters().id;
+    	var formIds = [];
+    	formIds.push(formTarget.getParameters().id);    	
     	
     	var targets = formTarget.getSubTargets('form-entry');
     	if (targets.length > 0)
@@ -258,11 +292,11 @@
     	                    var serverMessage = new org.ametys.servercomm.ServerMessage(
     	                        'forms',
     	                        '/form/delete-entries',
-    	                        {siteName: context.parameters.siteName, formId: formId, ids: entryIds}, 
+    	                        {siteName: context.parameters.siteName, formIds: formIds, ids: entryIds}, 
     	                        org.ametys.servercomm.ServerComm.PRIORITY_MAJOR,
     	                        org.ametys.forms.entry.DeleteEntry._deleteEntriesCb, 
     	                        this, 
-    	                        [entryIds, formId]
+    	                        [entryIds, formIds[0]]
     	                    );
     	                    org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
     	                }
@@ -285,7 +319,7 @@
     var entryIds = args[0];
     for (var i=0; i &lt; entryIds.length; i++)
 	{
-    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': entryIds[0], 'form': args[1] }));
+    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('form-entry', {'id': entryIds[i], 'form': args[1] }));
 	}
     
     var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED, null, targets);
@@ -295,28 +329,34 @@
 //------------------------------------------------------------
 
 /**
- * Clear all entries from a form.
+ * Clear all entries from at least one form.
  */
 org.ametys.forms.entry.ClearEntries = function(controlId, controlConfiguration, controlPluginName)
 {
 	var targets = org.ametys.ribbon.RibbonManager.getInstance().getCurrentSelectionTargets();
-	var formTarget = org.ametys.messagebus.message.MessageTargetHelper.findFirst(targets, function (target) { return target.getType() == 'content-form'});
+	var allFormTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets, function (target) { return target.getType() == 'content-form'});
 
-	if (formTarget != null)
+	if (allFormTargets.length &gt; 0)
 	{
+		var formIds = [];
+		for (var i = 0; i &lt; allFormTargets.length; i++)
+		{
+			formIds.push(allFormTargets[i].getParameters().id);
+		}
+		
 		Ext.Msg.confirm("<i18n:text i18n:key="PLUGINS_FORMS_CLEAR_ENTRIES_CONFIRM_TITLE"/>", 
-		        "<i18n:text i18n:key="PLUGINS_FORMS_CLEAR_ENTRIES_CONFIRM"/>", 
+				formIds.length &gt; 1 ? "<i18n:text i18n:key="PLUGINS_FORMS_CLEAR_ENTRIES_CONFIRM_SEVERAL"/>" : "<i18n:text i18n:key="PLUGINS_FORMS_CLEAR_ENTRIES_CONFIRM_SINGLE"/>", 
 		        function (answer) {
 		            if (answer == 'yes')
 		            {
 		                var serverMessage = new org.ametys.servercomm.ServerMessage(
 		                    'forms',
 		                    '/form/clear-entries',
-		                    {siteName: context.parameters.siteName, formId: formTarget.getParameters().id}, 
+		                    {siteName: context.parameters.siteName, formIds: formIds}, 
 		                    org.ametys.servercomm.ServerComm.PRIORITY_MAJOR,
 		                    org.ametys.forms.entry.ClearEntries._clearEntriesCb, 
 		                    this, 
-		                    [formTarget.getParameters().id]
+		                    [formIds]
 		                );
 		                org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
 		            }
@@ -333,8 +373,14 @@
         return;
     }
     
-    var formTarget = org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget("content-form", {'id': args[0]});
-    var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_METADATACHANGED, null, [formTarget]);
+    var formIds = args[0];
+    var targets = [];
+    for (var i = 0; i &lt; formIds.length; i++)
+	{
+    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {'id': formIds[i]}));
+	}
+    
+    var message = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_METADATACHANGED, null, targets);
     org.ametys.messagebus.MessageBus.getInstance().fireMessages([message]);
 }
 
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsButton.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsButton.js	(revision 39963)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsButton.js	(working copy)
@@ -1,5 +1,5 @@
 /*
- *  Copyright 2010 Anyware Services
+ *  Copyright 2016 Anyware Services
  *
  *  Licensed under the Apache License, Version 2.0 (the "License");
  *  you may not use this file except in compliance with the License.
@@ -21,7 +21,7 @@
 	org.ametys.forms.buttons.FormsButton.superclass.constructor.call(this, id, configuration, pluginName);
 };
 
-Ext.extend(org.ametys.forms.buttons.FormsButton, org.ametys.cms.ribbon.button.Menu, {});
+Ext.extend(org.ametys.forms.buttons.FormsButton, org.ametys.ribbon.control.button.ActionButton, {});
 
 /**
  * @private
Index: main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js
===================================================================
--- main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js	(revision 0)
+++ main/plugin-forms/resources/js/org/ametys/forms/FormsListTool.i18n.js	(revision 0)
@@ -0,0 +1,397 @@
+/*
+ *  Copyright 2016 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+Ext.namespace('org.ametys.forms.tool');
+
+org.ametys.forms.tool.FormsListTool = function(id, pluginName) 
+{
+    org.ametys.forms.tool.FormsListTool.superclass.constructor.call(this, id, pluginName);
+};
+
+Ext.extend(org.ametys.forms.tool.FormsListTool, org.ametys.uitool.tool.Tool, {});
+
+org.ametys.forms.tool.FormsListTool.prototype.createPanel = function()
+{
+    // The mapping for XML doc
+    var mapping = Ext.data.Record.create([
+        {name: 'id', mapping: '@id'},
+        {name: 'encodedLabel', mapping: '@encodedLabel'},
+        {name: 'name', mapping: 'name'},
+        {name: 'contentName', mapping: 'contentName'},
+        {name: 'answersAmount', mapping: 'answersAmount'},
+        {name: 'lastAnswer', mapping: 'lastAnswer'}
+    ]);
+    
+    // HTTP proxy
+    var proxy = new Ext.data.HttpProxy({
+        url: getPluginDirectUrl('forms') + '/forms-list.xml',
+        method: 'post',
+        timeout: 0
+    });
+    
+    // Data store
+    this._xmlStore = new Ext.data.Store({
+        proxy: proxy,
+        baseParams: {'siteName': context.parameters.siteName},
+        reader: new Ext.data.XmlReader({
+                record: 'form',
+                id: '@id'
+            },
+            mapping
+        ),
+    });
+    
+    this._xmlStore.on('beforeload', this._onBeforeLoad, this);
+    this._xmlStore.on('load', this._onLoad, this);
+    
+	this._langCombo = this._drawLanguageCombo();
+	this._loadLanguages();
+	
+	var langComboLabel = new Ext.form.Label({
+		width: 60, 
+		bodyStyle: {'textAlign': 'center'},
+    	text: "<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_LANGUAGE'/>"
+	});
+	
+	var langPanel = new Ext.Panel({
+		region: 'north',
+		border: false,
+		cls: 'formslist-tool-lang',
+		labelWidth: 30,
+		labelSeparator: '',
+        items: [langComboLabel, this._langCombo]
+    });
+	
+    this._grid = new Ext.grid.GridPanel({
+        region: 'center',
+        
+        store: this._xmlStore,
+        
+        viewConfig: {
+        	forceFit: true
+        },
+        
+        columns: [
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_COL_NAME'/>", width: 200, dataIndex: 'name'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_COL_CONTENT_NAME'/>", width: 200, dataIndex: 'contentName'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_COL_ANSWERS_AMOUNT'/>", width: 100, dataIndex: 'answersAmount'},
+            {header: "<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_COL_LAST_ANSWER'/>", width: 200, dataIndex: 'lastAnswer', renderer: this._renderDate}
+        ]
+    });
+    this._grid.getSelectionModel().on('selectionchange', this._onSelectForm, this);
+    this._grid.on('celldblclick', this._openFormEntriesTool, this);
+    
+    this._mainPanel = new Ext.Panel({
+        layout: 'border',
+        items: [langPanel, this._grid]
+    });
+    
+    this._mainPanel.addListener('focus', this._onFocus, this);
+    this._mainPanel.addListener('blur', this._onBlur, this);
+    this._mainPanel.addListener('afterrender', this.refresh, this);
+    this._mainPanel.addListener('close', this._onClose, this);
+    
+    return this._mainPanel;
+}
+
+org.ametys.forms.tool.FormsListTool.prototype.refresh = function(manual)
+{
+    this.refreshing();
+    
+    this._xmlStore.load();
+}
+
+/**
+ * Open the form entries tool corresponding to the clicked cell
+ * @param grid The grid
+ * @param rowIndex The selected row index
+ * @param columnIndex The selected column index
+ * @param e The event
+ */
+org.ametys.forms.tool.FormsListTool.prototype._openFormEntriesTool = function (grid, rowIndex, columnIndex, e)
+{
+	var record = grid.getSelectionModel().getSelected();
+	var id = record.get('id');
+	var label = record.get('name');
+	var encodedLabel = record.get('encodedLabel');
+	
+	org.ametys.uitool.ToolsManager.getInstance().openTool ("uitool-form-entries", { id: id, encodedLabel: encodedLabel, label: label});
+}
+
+/**
+ * @private
+ * Listener function invoked whenever the selection changes,
+ * Sends an selection event on the message bus
+ * @param Ext.grid.AbstractSelectionModel sm The selection model.
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onSelectForm = function(sm)
+{
+	window.clearTimeout(this._sendTimeout);
+	this._sendTimeout = this._sendSelectionMessage.defer(10, this, [sm.getSelections()]);
+}
+
+org.ametys.forms.tool.FormsListTool.prototype._sendSelectionMessage = function(records)
+{
+    var targets = [];
+    
+    for (var i=0; i &lt; records.length; i++)
+    {
+    	targets.push(org.ametys.messagebus.bus.MessageBuilder.getInstance().createTarget('content-form', {
+    		'id': records[i].data.id, 
+    		'encodedLabel': records[i].data.encodedLabel,
+    		'hasEntries': records[i].data.answersAmount > 0
+		}));
+    }
+	
+    var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, targets);
+	org.ametys.messagebus.MessageBus.getInstance().fireMessages([event]);
+}
+
+org.ametys.forms.tool.FormsListTool.prototype.onMessage = function(messages)
+{
+	for (var i = messages.length - 1; i >= 0; i--)
+    {
+    	var messageType = messages[i].getType().getName();
+        if (messageType == org.ametys.ribbon.RibbonManager.EVENTTYPE_METADATACHANGED)
+        {
+        	var targets = messages[i].getTargets();
+            var allTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets,function(target) { return target.getType() == "content-form" || target.getType() == "content";});
+        	
+            if (allTargets.length &gt; 0)
+        	{
+            	this.outOfDate();
+        	}
+        }
+        else if (messageType == org.ametys.ribbon.RibbonManager.EVENTTYPE_CREATED)
+    	{
+        	var targets = messages[i].getTargets();
+            var allTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets,function(target) { return target.getType() == "content";});
+        	
+            if (allTargets.length &gt; 0)
+        	{
+            	this.outOfDate();
+        	}
+    	}
+        else if (messageType == org.ametys.ribbon.RibbonManager.EVENTTYPE_DELETED)
+    	{
+        	var targets = messages[i].getTargets();
+            var allTargets = org.ametys.messagebus.message.MessageTargetHelper.findAll(targets,function(target) { return target.getType() == "content" || target.getType() == "form-entry";});
+        	
+            if (allTargets.length &gt; 0)
+        	{
+            	this.outOfDate();
+        	}
+    	}
+    }
+}
+
+org.ametys.forms.tool.FormsListTool.prototype._drawLanguageCombo = function()
+{
+    var langStore = new Ext.data.SimpleStore({
+        fields: ['lang', 'langlabel', 'langimage', 'langfull'],
+        data: []
+    });
+    
+    var combo = new Ext.form.ComboBox({
+        width: 160,
+        minListWidth: 120,
+        
+        forceSelection: true,
+        editable: false,
+        mode: 'local',
+        resizable: false,
+        triggerAction: 'all',
+        
+        store: langStore,
+        
+        name: 'lang',
+        valueField: 'lang',
+        displayField: 'langfull',
+        
+        tpl: new Ext.XTemplate(
+                '&lt;tpl for="."&gt;',
+                    '&lt;div class="x-combo-list-item combo-list-lang-item"&gt;',
+                        '&lt;img src="{langimage}" style="float:left; margin-right: 3px"/&gt;', 
+                        '{langlabel} &lt;em&gt;({lang})&lt;/em&gt;',
+                        '&lt;div class="x-clear"&gt;&lt;/div&gt;',
+                    '&lt;/div&gt;',
+                '&lt;/tpl&gt;')
+    });
+    
+    combo.addListener('select', this._langChange, this);
+    
+    return combo;
+}
+
+org.ametys.forms.tool.FormsListTool.prototype._loadLanguages = function()
+{
+    var serverMessage = new org.ametys.servercomm.ServerMessage('web', '/repository/languages.xml', {'siteName': context.parameters.siteName}, org.ametys.servercomm.ServerComm.PRIORITY_MAJOR, this._loadLanguagesCb, this, []);
+    org.ametys.servercomm.ServerComm.getInstance().send(serverMessage);
+}
+
+org.ametys.forms.tool.FormsListTool.prototype._loadLanguagesCb = function(response, args)
+{
+    if (org.ametys.servercomm.ServerComm.handleBadResponse("<i18n:text i18n:key='PLUGINS_FORMS_UITOOL_FORMS_LIST_GET_LANGUAGES_ERROR'/>", response, "org.ametys.forms.tool.FormsListTool._loadLanguagesCb"))
+    {
+        return;
+    }
+    
+    var store = this._langCombo.getStore();
+    store.removeAll();	
+    
+    this.defaultLang = null;
+    var isThereEn = false;
+    var ok = false;
+    
+    var languages = response.selectNodes('sitemaps/sitemap');
+    for (var i=0; i &lt; languages.length; i++)
+    {
+        if (!ok)
+        {
+            // Find the default language
+            if (this._lang == languages[i].getAttribute('name'))
+            {
+                this.defaultLang = languages[i].getAttribute('name');
+                ok = true;
+            }
+            else if (context.parameters.userLocale == languages[i].getAttribute('name'))
+            {
+                this.defaultLang = context.parameters.userLocale;
+            }
+            if (languages[i].getAttribute('name') == 'en')
+            {
+                isThereEn = true;
+            }
+        }
+        
+        var data = {
+            lang: languages[i].getAttribute('name'),
+            langlabel: languages[i].selectSingleNode('label')[org.ametys.servercomm.ServerComm.xmlTextContent],
+            langimage: context.contextPath + languages[i].selectSingleNode ('small-icon')[org.ametys.servercomm.ServerComm.xmlTextContent],
+            langfull: languages[i].selectSingleNode('label')[org.ametys.servercomm.ServerComm.xmlTextContent] + ' (' + languages[i].getAttribute('name') + ')'
+        };
+        store.add(new store.recordType(data));
+    }
+    
+    if (this.defaultLang == null)
+    {
+        if (isThereEn)
+        {
+            this.defaultLang = 'en';
+        }
+        else
+        {
+            this.defaultLang = languages[0].getAttribute('name');
+        }
+    }
+    
+    // Initialize with default value
+    this._langCombo.setValue(this.defaultLang);
+    this._lang = this.defaultLang;
+    store.sort('lang', 'ASC');
+    this.refresh();
+}
+
+org.ametys.forms.tool.FormsListTool.prototype._langChange = function(combo, record, index)
+{
+    if (this._lang == record.data.lang)
+    {
+        return;
+    }
+    
+    this._lang = record.data.lang;
+    
+    // Refresh the tool content.
+    this.refresh();
+}
+
+
+org.ametys.forms.tool.FormsListTool.prototype._renderDate = function(value, p, record)
+{
+	var dateFormat = "<i18n:text i18n:key="PLUGINS_FORMS_DATETIME_FORMAT"/>";
+	return Ext.util.Format.date(value, dateFormat);
+}
+
+/**
+ * Listens when the store is about to load or reload.
+ * @private
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onBeforeLoad = function(store, options)
+{
+	// Let the load occur only if we know the language.
+	if (this._lang == null)
+	{
+		return false;
+	}
+	
+	store.baseParams.language = this._lang;
+}
+
+/**
+ * Listens when the store has loaded records.
+ * @private
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onLoad = function(store, records, options)
+{
+    this.upToDate();
+    this._updateSelections();
+}
+
+/**
+ * Listens when the panel receives the focus.
+ * @private
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onFocus = function(messages)
+{
+    this._hasFocus = true;
+    this._updateSelections();
+}
+
+/**
+ * Listens when the panel looses the focus.
+ * @private
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onBlur = function(messages)
+{
+    this._hasFocus = false;
+}
+
+/**
+ * Listens when the panel is closed.
+ * @private
+ */
+org.ametys.forms.tool.FormsListTool.prototype._onClose = function(messages)
+{
+	if (this._hasFocus)
+	{
+		var event = org.ametys.messagebus.bus.MessageBuilder.getInstance().createMessage(org.ametys.ribbon.RibbonManager.EVENTTYPE_SELECTIONCHANGED, null, []);
+		var eventBus =  org.ametys.messagebus.MessageBus.getInstance();
+		eventBus.fireMessages([event]);
+	}
+}
+
+/**
+ * @private
+ * Update the selections
+ */
+org.ametys.forms.tool.FormsListTool.prototype._updateSelections = function ()
+{
+	var records = this._grid.getSelectionModel().getSelections();
+	if (records.length &gt; 0)
+	{
+	    this._sendSelectionMessage(records);
+	}
+}
